﻿Type=Activity
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private streamer As AudioStreamer
	Private buffers As List
	Private timer1 As Timer
	Private recordingStart As Long
End Sub

Sub Globals
	Dim Label1 As Label
	Dim btnPlay As Button
	Dim btnStartRecording As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("sound")
	If FirstTime Then
		streamer.Initialize("streamer", 44100, True, 16, streamer.VOLUME_MUSIC)
		buffers.Initialize
		timer1.Initialize("timer1", 1000)
	End If
End Sub

Sub streamer_RecordBuffer (Buffer() As Byte)
	'collect the recording data
	buffers.Add(Buffer)
End Sub

Sub btnStartRecording_Click
	buffers.Clear
	streamer.StartRecording
	recordingStart = DateTime.Now
	timer1.Enabled = True
	Timer1_Tick
	btnPlay.Enabled = False
End Sub

Sub Timer1_Tick
	Label1.Text = "Recording: " & _
		Round((DateTime.Now - recordingStart) / DateTime.TicksPerSecond) & " seconds"
End Sub

Sub btnStopRecording_Click
	streamer.StopRecording
	timer1.Enabled = False
	btnPlay.Enabled = True
	Label1.Text = ""
End Sub

Sub btnPlay_Click
	btnStartRecording.Enabled = False
	streamer.StartPlaying
	For Each b() As Byte In buffers
		streamer.Write(b)
	Next
	streamer.Write(Null) 'when this "message" will be processed, the player will stop.
End Sub

Sub streamer_PlaybackComplete
	Log("PlaybackComplete")
	btnStartRecording.Enabled = True
End Sub

Sub Activity_Resume
	Starter.rp.CheckAndRequest(Starter.rp.PERMISSION_RECORD_AUDIO)
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Activity_PermissionResult (Permission As String, Result As Boolean)
	If Permission = Starter.rp.PERMISSION_RECORD_AUDIO Then

	End If
End Sub